## dracut 103

=== debian/changelog ===
dracut (103-1ubuntu3.1) oracular; urgency=medium

  * Fix missing compressed blobs that match wildcard fwpath (LP: #2095518)

 -- You-Sheng Yang <vicamo@gmail.com>  Thu, 13 Feb 2025 15:16:38 +0100

dracut (103-1ubuntu3) oracular; urgency=medium

  * Regenerate only the latest and missing initrds (LP: #2048990)
  * Include all packages with dracut modules in Apport bug reports
    (LP: #2081183)

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 30 Sep 2024 15:04:58 +0200

dracut (103-1ubuntu2) oracular; urgency=medium

  * autopkgtest: Drop dmraid upstream test 14 (LP: #2073677)
  * Add systemd-coredump, systemd-cryptsetup, and systemd-repart as
    dependencies for upstream-dracut-core autopkgtest.

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 03 Sep 2024 11:02:08 +0200

dracut (103-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - autopkgtest: Enable dmraid upstream test 14
    - Run upstream autopkgtest as root
    - disable using DH_VERBOSE=1
    - dracut-core: add new modules 01systemd-bsod, 01systemd-creds, 90numlock,
      90pcmcia
    - Explicitly mark 45ifcfg module as not installed
    - Switch to debhelper 13
    - dracut: use await variant of update-initramfs trigger
    - drop udevsettle patch (these kind of patches should be applied upstream)
    - drop nm-path patch (network-manager ships the helpers in /usr/libexec)
    - drop 90overlay-root in favor of 90overlayfs (Closes: #1017039)
    - run autopkgtest with V=2
    - run autopkgtest on all architectures
    - autopkgtest: disable using KVM for ppc64el
    - autopkgtest: set ARCH to dpkg architecture
    - dracut-core:
      - drop recommending pkgconf
      - drop depending directly on libkmod2. dracut-install links against it.
      - demote cryptsetup, dmraid, dmsetup, kpartx, lvm2, mdadm to suggests
      - demote binutils to suggests. its only needed when using UEFI executables
      - recommend zstd instead of pigz and default to zstd
    - Drop dracut-config-generic. Building a generic image is and will be the
      default.
    - Default initrdname to initrd.img-${kernel}
  * All submitted patches were accepted upstream and could be dropped.

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 09 Aug 2024 11:26:10 +0200

dracut (103-1) unstable; urgency=low

  * new upstream version 103
  * sync and delete patches
  * add new dracut module

 -- Thomas Lange <lange@debian.org>  Thu, 25 Jul 2024 13:30:18 +0900

=== debian/control ===
Source: dracut
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Lange <lange@debian.org>
Build-Depends: debhelper-compat (= 13), debhelper, dh-apport, asciidoc-base, xsltproc, docbook-xsl, docbook-xml, quilt, libkmod-dev, pkgconf, systemd-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/dracut
Vcs-Git: https://salsa.debian.org/debian/dracut.git
Homepage: https://github.com/dracut-ng/dracut-ng/wiki

Package: dracut-core
Architecture: any
Multi-Arch: foreign
Recommends: console-setup, systemd, zstd
Depends: cpio, dracut-install, kmod, udev, e2fsprogs, ${shlibs:Depends}, ${misc:Depends}
Suggests: binutils, cryptsetup, dmraid, dmsetup, kpartx, lvm2, mdadm
Breaks: dracut-network (<< 057+157-2), dracut-live (<< 059-2)
Replaces: dracut-network (<< 057+157-2), dracut-live (<< 059-2)
Description: dracut is an event driven initramfs infrastructure (core tools)
 Unlike existing initramfs's, this is an attempt at having as little as
 possible hard-coded into the initramfs as possible.  The initramfs has
 (basically) one purpose in life -- getting the rootfs mounted so that
 we can transition to the real rootfs.  This is all driven off of
 device availability.  Therefore, instead of scripts hard-coded to do
 various things, we depend on udev to create device nodes for us and
 then when we have the rootfs's device node, we mount and carry on.
 Having the root on MD, LVM2, LUKS is supported as well as NFS, iSCSI,
 NBD and FCOE with dracut-network.

Package: dracut
Architecture: all
Multi-Arch: foreign
Suggests: dracut-network
Depends: dracut-core (>= ${binary:Version}), dracut-core (<< ${binary:Version}+b+~), linux-base, ${misc:Depends}
Provides: linux-initramfs-tool
Conflicts: initramfs-tools, live-tools
Description: Initramfs generator using udev
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: dracut-install
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: dracut-core (<< 060+5-7~)
Replaces: dracut-core (<< 060+5-7~)
Description: dracut is an event driven initramfs infrastructure (dracut-install)
 This package just contains the dracut-install command to be used by
 initramfs generating tools.

Package: dracut-network
Architecture: all
Recommends: nfs-common, open-iscsi, nbd-client, curl
Depends: dracut-core, iputils-arping, isc-dhcp-client | systemd | connman | network-manager, ${misc:Depends}
Description: dracut is an event driven initramfs infrastructure (network modules)
 Package to build a dracut initramfs with network support. This
 includes dracut modules for NFS, CIFS, iSCSI, HTTP, NBD, FCP and FCOE.

Package: dracut-squash
Architecture: all
Depends: dracut-core, squashfs-tools, ${misc:Depends}
Breaks: dracut-core (<< 050-1)
Replaces: dracut-core (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (squashfs modules)
 Package to build an initramfs with most files in a squashfs image.
 .
 This package provides a dracut module to build an initramfs, but
 store most files in a squashfs image, result in a smaller initramfs
 size and reduce runtime memory usage.

Package: dracut-live
Architecture: all
Recommends: dracut-network
Depends: dracut-core, dmsetup, ${misc:Depends}
Breaks: dracut-network (<< 050-1), dracut-core (<< 050-1)
Replaces: dracut-network (<< 050-1), dracut-core (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (live image modules)
 Package to build a dracut initramfs with live image capabilities.
 .
 This package requires everything which is needed to build an
 initramfs with dracut, with live image capabilities, like Live CDs.

Package: dracut-config-rescue
Architecture: all
Depends: dracut-core, ${misc:Depends}
Multi-Arch: foreign
Description: dracut is an event driven initramfs infrastructure
 This is the dracut configuration to turn on rescue image generation

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DRACUT_MAIN_VERSION=$(DEB_VERSION_UPSTREAM_REVISION)
export DRACUT_FULL_VERSION=$(DEB_VERSION)

deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)

%:
	dh $@ --with apport

override_dh_auto_configure:
	dh_auto_configure -- --systemdsystemunitdir=/$(deb_systemdsystemunitdir) --libdir=/usr/lib
	$(SHELL) debian/fix-revdate
	mv dracut-version.sh dracut-version.sh.orig
	echo '#!/bin/sh' > dracut-version.sh
	echo "DRACUT_VERSION=$${DRACUT_FULL_VERSION}" >> dracut-version.sh

override_dh_fixperms-arch:
	dh_fixperms
	find debian/ -name "*.sh" | grep modules.d | xargs chmod 755

override_dh_fixperms-indep:
	dh_fixperms
	find debian/ -name "*.sh" | grep modules.d | xargs chmod 755
	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.asc
	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.8
ifneq ($(DEB_HOST_ARCH), s390x)
	for m in 80cms 81cio_ignore 91zipl 95dasd 95dasd_mod \
		95dcssblk 95zfcp \
		95znet; do \
		rm -rf debian/*/usr/lib/dracut/modules.d/$$m ; \
	done
else
	rm -rf debian/*/usr/lib/dracut/modules.d/00warpclock
endif

override_dh_auto_test:

override_dh_install:
	dh_install
	dh_install -pdracut-core $(deb_systemdsystemunitdir)

override_dh_clean:
	if test -e dracut-version.sh.orig ; then \
	   mv -f dracut-version.sh.orig dracut-version.sh ;\
	fi
	dh_clean dracut.pc Makefile.inc src/skipcpio/skipcpio src/util/util
	git status|grep modified: | awk '/.asc/ {print $$2}' | xargs -r git checkout

=== debian/tests/control ===
# Note: These tests need root on Ubuntu, because the kernel is only readable by root. See https://launchpad.net/bugs/759725
# Skip following test cases:
# * TEST-14-IMSM: dmraid was removed from Debian
# * TEST-20-NFS: https://github.com/dracutdevs/dracut/issues/1901
# * TEST-30-ISCSI: https://github.com/dracutdevs/dracut/issues/2497
# * TEST-35-ISCSI-MULTI: https://github.com/dracutdevs/dracut/issues/2498
# * TEST-50-MULTINIC: disabled in upstream CI since 2023-01-02
# * TEST-60-BONDBRIDGEVLAN: https://github.com/dracutdevs/dracut/issues/2328
# arm64, armhf, ppc64el, and s390x need upstream support: https://github.com/dracutdevs/dracut/issues/2493
Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Test-Command: debian/tests/run-upstream-tests SKIP="14 16 20 30 35 40 50 60"
Depends: btrfs-progs,
         busybox,
         cryptsetup,
         dracut-core,
         fdisk,
         gawk,
         kbd,
         linux-image-generic,
         lvm2,
         make,
         mdadm,
         mount,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         systemd-boot-efi,
         systemd-coredump,
         systemd-cryptsetup,
         systemd-repart,
         systemd-sysv,
         util-linux
Restrictions: allow-stderr, needs-root
Features: test-name=upstream-dracut-core

Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Test-Command: debian/tests/run-upstream-tests TESTS="16"
Depends: btrfs-progs,
         busybox,
         dracut-live,
         fdisk,
         kbd,
         linux-image-generic,
         make,
         mount,
         parted,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         squashfs-tools,
         systemd-sysv,
         util-linux
Restrictions: allow-stderr, needs-root
Features: test-name=upstream-dracut-live

Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Test-Command: debian/tests/run-upstream-tests TESTS="40"
Depends: cryptsetup,
         dracut-network,
         gawk,
         iproute2,
         iputils-ping,
         isc-dhcp-client,
         isc-dhcp-server,
         linux-image-generic,
         lvm2,
         make,
         mdadm,
         mount,
         nbd-client,
         nbd-server,
         procps,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         systemd-sysv,
         util-linux,
         vim
Restrictions: allow-stderr, needs-root
Features: test-name=upstream-dracut-network

## dracut 105

=== Makefile ===
-include dracut-version.sh

DRACUT_MAIN_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --abbrev=0 --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_MAIN_VERSION),)
DRACUT_MAIN_VERSION = $(DRACUT_VERSION)
endif
DRACUT_FULL_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_FULL_VERSION),)
DRACUT_FULL_VERSION = $(DRACUT_VERSION)
endif

HAVE_SHELLCHECK ?= $(shell command -v shellcheck >/dev/null 2>&1 && echo yes)
HAVE_SHFMT ?= $(shell command -v shfmt >/dev/null  2>&1 && echo yes)

-include Makefile.inc

KVERSION ?= $(shell uname -r)

prefix ?= /usr
libdir ?= ${prefix}/lib
datadir ?= ${prefix}/share
pkglibdir ?= ${libdir}/dracut
sysconfdir ?= ${prefix}/etc
bindir ?= ${prefix}/bin
mandir ?= ${prefix}/share/man
CFLAGS ?= -O2 -g -Wall -std=gnu99 -D_FILE_OFFSET_BITS=64 -Wformat -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2
bashcompletiondir ?= ${datadir}/bash-completion/completions
pkgconfigdatadir ?= $(datadir)/pkgconfig

man1pages = man/lsinitrd.1

man5pages = man/dracut.conf.5

man7pages = man/dracut.cmdline.7 \
            man/dracut.bootup.7 \
            man/dracut.modules.7

man8pages = man/dracut.8 \
            man/dracut-catimages.8 \
            modules.d/98dracut-systemd/dracut-cmdline.service.8 \
            modules.d/98dracut-systemd/dracut-initqueue.service.8 \
            modules.d/98dracut-systemd/dracut-mount.service.8 \
            modules.d/98dracut-systemd/dracut-shutdown.service.8 \
            modules.d/98dracut-systemd/dracut-pre-mount.service.8 \
            modules.d/98dracut-systemd/dracut-pre-pivot.service.8 \
            modules.d/98dracut-systemd/dracut-pre-trigger.service.8 \
            modules.d/98dracut-systemd/dracut-pre-udev.service.8

manpages = $(man1pages) $(man5pages) $(man7pages) $(man8pages)

.PHONY: install clean archive testimage test all check AUTHORS CONTRIBUTORS doc

all: dracut.pc dracut-install src/skipcpio/skipcpio dracut-util

%.o : %.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(KMOD_CFLAGS) $< -o $@

DRACUT_INSTALL_OBJECTS = \
        src/install/dracut-install.o \
        src/install/hashmap.o\
        src/install/log.o \
        src/install/strv.o \
        src/install/util.o

# deps generated with gcc -MM
src/install/dracut-install.o: src/install/dracut-install.c src/install/log.h src/install/macro.h \
	src/install/hashmap.h src/install/util.h
src/install/hashmap.o: src/install/hashmap.c src/install/util.h src/install/macro.h src/install/log.h \
	src/install/hashmap.h
src/install/log.o: src/install/log.c src/install/log.h src/install/macro.h src/install/util.h
src/install/util.o: src/install/util.c src/install/util.h src/install/macro.h src/install/log.h
src/install/strv.o: src/install/strv.c src/install/strv.h src/install/util.h src/install/macro.h src/install/log.h

src/install/dracut-install: $(DRACUT_INSTALL_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(DRACUT_INSTALL_OBJECTS) $(LDLIBS) $(FTS_LIBS) $(KMOD_LIBS)

dracut-install: src/install/dracut-install
	ln -fs $< $@

SKIPCPIO_OBJECTS = src/skipcpio/skipcpio.o
skipcpio/skipcpio.o: src/skipcpio/skipcpio.c
skipcpio/skipcpio: $(SKIPCPIO_OBJECTS)

UTIL_OBJECTS = src/util/util.o
util/util.o: src/util/util.c
util/util: $(UTIL_OBJECTS)

dracut-util: src/util/util
	cp -a $< $@

.PHONY: indent-c
indent-c:
	astyle -n --quiet --options=.astylerc $(wildcard *.[ch] */*.[ch] src/*/*.[ch])

.PHONY: indent
indent: indent-c
ifeq ($(HAVE_SHFMT),yes)
	shfmt -w -s .
endif

src/dracut-cpio/target/release/dracut-cpio: src/dracut-cpio/src/main.rs
	cargo --offline build --release --manifest-path src/dracut-cpio/Cargo.toml

dracut-cpio: src/dracut-cpio/target/release/dracut-cpio
	ln -fs $< $@

ifeq ($(enable_dracut_cpio),yes)
all: dracut-cpio
endif

doc: $(manpages) dracut.html

ifneq ($(enable_documentation),no)
all: doc
endif

%: %.xml
	@rm -f -- "$@"
	xsltproc -o "$@" -nonet http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl $<

%.xml: %.adoc
	@rm -f -- "$@"
	asciidoc -a "version=$(DRACUT_FULL_VERSION)" -d manpage -b docbook -o "$@" $<

dracut.8: man/dracut.8.adoc \
	man/dracut.usage.adoc

dracut.html: man/dracut.adoc $(manpages) docs/dracut.css man/dracut.usage.adoc
	@rm -f -- dracut.xml
	asciidoc -a "mainversion=$(DRACUT_MAIN_VERSION)" \
		-a "version=$(DRACUT_FULL_VERSION)" \
		-a numbered \
		-d book -b docbook -o dracut.xml man/dracut.adoc
	@rm -f -- dracut.html
	xsltproc -o dracut.html --xinclude -nonet \
		--stringparam custom.css.source docs/dracut.css \
		--stringparam generate.css.header 1 \
		http://docbook.sourceforge.net/release/xsl/current/xhtml/docbook.xsl dracut.xml
	@rm -f -- dracut.xml

dracut.pc: Makefile.inc Makefile
	@echo "Name: dracut" > dracut.pc
	@echo "Description: dracut" >> dracut.pc
	@echo "Version: $(DRACUT_FULL_VERSION)" >> dracut.pc
	@echo "dracutdir=$(pkglibdir)" >> dracut.pc
	@echo "dracutmodulesdir=$(pkglibdir)/modules.d" >> dracut.pc
	@echo "dracutconfdir=$(pkglibdir)/dracut.conf.d" >> dracut.pc

install: all
	mkdir -p $(DESTDIR)$(pkglibdir)
	mkdir -p $(DESTDIR)$(bindir)
	mkdir -p $(DESTDIR)$(sysconfdir)
	mkdir -p $(DESTDIR)$(pkglibdir)/modules.d
	mkdir -p $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man5 $(DESTDIR)$(mandir)/man7 $(DESTDIR)$(mandir)/man8
	install -m 0755 dracut.sh $(DESTDIR)$(bindir)/dracut
	install -m 0755 dracut-catimages.sh $(DESTDIR)$(bindir)/dracut-catimages
	install -m 0755 lsinitrd.sh $(DESTDIR)$(bindir)/lsinitrd
	install -m 0644 dracut.conf $(DESTDIR)$(sysconfdir)/dracut.conf
	mkdir -p $(DESTDIR)$(sysconfdir)/dracut.conf.d
	mkdir -p $(DESTDIR)$(pkglibdir)/dracut.conf.d
	install -m 0755 dracut-init.sh $(DESTDIR)$(pkglibdir)/dracut-init.sh
	install -m 0755 dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions.sh
	install -m 0755 dracut-version.sh $(DESTDIR)$(pkglibdir)/dracut-version.sh
	ln -fs dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions
	install -m 0755 dracut-logger.sh $(DESTDIR)$(pkglibdir)/dracut-logger.sh
	install -m 0755 dracut-initramfs-restore.sh $(DESTDIR)$(pkglibdir)/dracut-initramfs-restore
	cp -arx modules.d dracut.conf.d $(DESTDIR)$(pkglibdir)
ifneq ($(enable_test),no)
	cp -arx test $(DESTDIR)$(pkglibdir)
else
	rm -rf $(DESTDIR)$(pkglibdir)/modules.d/80test*
endif
ifneq ($(enable_documentation),no)
	for i in $(man1pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man1/$${i##*/}; done
	for i in $(man5pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man5/$${i##*/}; done
	for i in $(man7pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man7/$${i##*/}; done
	for i in $(man8pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man8/$${i##*/}; done
	ln -fs dracut.cmdline.7 $(DESTDIR)$(mandir)/man7/dracut.kernel.7
endif
	if [ -n "$(systemdsystemunitdir)" ]; then \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir); \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/98dracut-systemd/dracut-shutdown-onfailure.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown-onfailure.service; \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/98dracut-systemd/dracut-shutdown.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants; \
		ln -s ../dracut-shutdown.service \
		$(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants; \
		for i in \
		    dracut-cmdline.service \
		    dracut-initqueue.service \
		    dracut-mount.service \
		    dracut-pre-mount.service \
		    dracut-pre-pivot.service \
		    dracut-pre-trigger.service \
		    dracut-pre-udev.service \
		    ; do \
			ln -srf $(DESTDIR)$(pkglibdir)/modules.d/98dracut-systemd/$$i $(DESTDIR)$(systemdsystemunitdir); \
			ln -s ../$$i \
			$(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants/$$i; \
		done \
	fi
	if [ -f src/install/dracut-install ]; then \
		install -m 0755 src/install/dracut-install $(DESTDIR)$(pkglibdir)/dracut-install; \
	fi
	if [ -f src/skipcpio/skipcpio ]; then \
		install -m 0755 src/skipcpio/skipcpio $(DESTDIR)$(pkglibdir)/skipcpio; \
	fi
	if [ -f dracut-util ]; then \
		install -m 0755 dracut-util $(DESTDIR)$(pkglibdir)/dracut-util; \
	fi
ifeq ($(enable_dracut_cpio),yes)
	install -m 0755 dracut-cpio $(DESTDIR)$(pkglibdir)/dracut-cpio
endif
	mkdir -p $(DESTDIR)${prefix}/lib/kernel/install.d
	install -m 0755 install.d/50-dracut.install $(DESTDIR)${prefix}/lib/kernel/install.d/50-dracut.install
	install -m 0755 install.d/51-dracut-rescue.install $(DESTDIR)${prefix}/lib/kernel/install.d/51-dracut-rescue.install
	mkdir -p $(DESTDIR)${bashcompletiondir}
	install -m 0644 shell-completion/bash/dracut $(DESTDIR)${bashcompletiondir}/dracut
	install -m 0644 shell-completion/bash/lsinitrd $(DESTDIR)${bashcompletiondir}/lsinitrd
	mkdir -p $(DESTDIR)${pkgconfigdatadir}
	install -m 0644 dracut.pc $(DESTDIR)${pkgconfigdatadir}/dracut.pc

clean:
	$(RM) *~
	$(RM) */*~
	$(RM) */*/*~
	$(RM) $(manpages:%=%.xml) dracut.xml
	$(RM) test-*.img
	$(RM) dracut-*.tar.bz2 dracut-*.tar.xz
	$(RM) dracut-install src/install/dracut-install $(DRACUT_INSTALL_OBJECTS)
	$(RM) skipcpio/skipcpio $(SKIPCPIO_OBJECTS)
	$(RM) dracut-util util/util $(UTIL_OBJECTS)
	$(RM) $(manpages)
	$(RM) dracut.pc
	$(RM) dracut-cpio src/dracut-cpio/target/release/dracut-cpio*
	$(MAKE) -C test clean

syncheck:
	@ret=0;for i in dracut-initramfs-restore.sh modules.d/*/*.sh; do \
                [ "$${i##*/}" = "module-setup.sh" ] && continue; \
                read line < "$$i"; [ "$${line#*bash*}" != "$$line" ] && continue; \
		[ $$V ] && echo "posix syntax check: $$i"; bash --posix -n "$$i" ; ret=$$(($$ret+$$?)); \
		[ $$V ] && echo "checking for [[: $$i"; if grep -Fq '[[ ' "$$i" ; then ret=$$(($$ret+1)); echo "$$i contains [["; fi; \
		[ $$V ] && echo "checking for echo -n: $$i"; if grep -Fq 'echo -n ' "$$i" ; then ret=$$(($$ret+1)); echo "$$i contains echo -n"; fi \
	done;exit $$ret
	@ret=0;for i in *.sh modules.d/*/*.sh modules.d/*/module-setup.sh; do \
		[ $$V ] && echo "bash syntax check: $$i"; bash -n "$$i" ; ret=$$(($$ret+$$?)); \
	done;exit $$ret
ifeq ($(HAVE_SHELLCHECK),yes)
ifeq ($(HAVE_SHFMT),yes)
	shellcheck $$(shfmt -f .)
else
	find . -name '*.sh' -print0 | xargs -0 shellcheck
endif
endif

check: all syncheck
	@$(MAKE) -C test check

testimage: all
	./dracut.sh -N -l -a debug -f test-$(KVERSION).img $(KVERSION)
	@echo wrote  test-$(KVERSION).img

debugtestimage: all
	./dracut.sh --debug -l -a debug -f test-$(KVERSION).img $(KVERSION)
	@echo wrote  test-$(KVERSION).img

testimages: all
	./dracut.sh -l -a debug --kernel-only -f test-kernel-$(KVERSION).img $(KVERSION)
	@echo wrote  test-$(KVERSION).img
	./dracut.sh -l -a debug --no-kernel -f test-dracut.img $(KVERSION)
	@echo wrote  test-dracut.img

debughostimage: all
	./dracut.sh --debug -H -l -f test-$(KVERSION).img $(KVERSION)
	@echo wrote  test-$(KVERSION).img

hostimage: all
	./dracut.sh -H -l -f test-$(KVERSION).img $(KVERSION)
	@echo wrote  test-$(KVERSION).img

efi: all
	./dracut.sh --uefi -H -l -f linux-$(KVERSION).efi $(KVERSION)
	@echo wrote linux-$(KVERSION).efi

AUTHORS:
	@git log | git shortlog --numbered --summary -e | while read -r a rest || [ -n "$$rest" ]; do echo "$$rest"; done > AUTHORS

CONTRIBUTORS:
	@git log | git shortlog $(DRACUT_MAIN_VERSION).. --numbered --summary -e | while read -r a rest || [ -n "$$rest" ]; do echo "- $$rest"; done

=== debian/changelog ===
dracut (105-3) unstable; urgency=medium

  * Add patches to improve test cases in error case
  * autopkgtest: add TEST-20-NFS test

 -- Benjamin Drung <bdrung@debian.org>  Tue, 07 Jan 2025 10:25:32 +0100

dracut (105-2) unstable; urgency=medium

  * autopkgtest:
    - run network tests with systemd-networkd
    - drop explicit gawk dependency
    - run test with zstd
    - restrict to amd64 again (Closes: #1087834)
    - update reasons for skipped tests
    - run tests with V=1
    - drop unneeded vim and iputils-ping dependencies
    - rename upstream-dracut-network to upstream-dracut-network-nbd
  * disable using DH_VERBOSE=1
  * fix(iscsi): include /usr/lib/open-iscsi/startup-checks.sh if needed
    (LP: #2081172)
  * Add upstream metadata
  * Let dracut-network recommend iscsiuio (for iscsi module)
  * fix(dracut-init): add compatibility with Debian/Ubuntu for libdirs detection

 -- Benjamin Drung <bdrung@debian.org>  Thu, 21 Nov 2024 14:30:47 +0100

dracut (105-1) unstable; urgency=low

  [ Thomas Lange ]
  * new upstream, Closes: #1081566
  * add systemd-cryptsetup as Recommends, Closes: #1078792
  * add Benjamin as uploader
  * update standards version, no changes needed
  * instead of depend on init, now recommend systemd-sysv, Closes: #1056382
  * Do not call clean target in tests, Closes: #1086085

  [ Benjamin Drung ]
  * dracut-core:
    - add new modules 00shell-interpreter, 01fips-crypto-policies,
      01systemd-bsod, 01systemd-creds, 90numlock, 90pcmcia
    - drop recommending pkgconf
    - drop depending directly on libkmod2. dracut-install links against it.
    - recommend zstd instead of pigz and default to zstd
  * Switch to debhelper 13
  * dracut: use await variant of update-initramfs trigger
  * drop nm-path patch (network-manager ships the helpers in /usr/libexec)
  * Add systemd-coredump, systemd-cryptsetup, and systemd-repart as
    dependencies for upstream-dracut-core autopkgtest.
  * Regenerate only the latest and missing initrds (LP: #2048990)
  * Move module 95nvmf from dracut-core to dracut-network (LP: #2083881)
  * Drop unneeded quilt from build dependencies
  * Default initrdname to initrd.img-${kernel}
  * Enable all hardening flags
  * fix-01fips-crypto-policies-use-bin-in-shebang.patch: use /bin in shebang
  * Add a dracut-test package to ship the files needed for the test suite
  * autopkgtest:
    - run autopkgtest with V=2 (for maximum verbosity)
    - run autopkgtest on all architectures
    - disable using KVM for ppc64el
    - set ARCH to dpkg architecture
    - Depend on ovmf, squashfs-tools, and systemd-ukify for TEST-18-UEFI
    - Depend on systemd-cryptsetup for TEST-40-NBD
    - restrict systemd-boot-efi to supported archs
  * dracut-config-generic: ship upstream 50-generic.conf instead of Debian
    specific one and put it into /usr/lib/dracut/dracut.conf.d
  * dracut-config-rescue: ship upstream 50-rescue.conf instead of Debian
    specific one and put it into /usr/lib/dracut/dracut.conf.d
  * Set Rules-Requires-Root: no
  * test: decrease default VM memory size to 1 GiB
  * Run wrap-and-sort

 -- Benjamin Drung <bdrung@debian.org>  Thu, 14 Nov 2024 12:29:30 +0100

dracut (103-2) unstable; urgency=low

  * control: add depends on gawk, init, Closes: #1056382, #1081005

 -- Thomas Lange <lange@debian.org>  Wed, 11 Sep 2024 11:16:43 +0200

dracut (103-1.1) unstable; urgency=medium

  * no changes non-maintainer upload to rebuild the package with a newer
    libkmod2 (see #1079022)

 -- Marco d'Itri <md@linux.it>  Tue, 20 Aug 2024 23:36:24 +0200

=== debian/control ===
Source: dracut
Section: utils
Priority: optional
Maintainer: Thomas Lange <lange@debian.org>
Uploaders: Benjamin Drung <bdrung@debian.org>
Build-Depends: asciidoc-base,
               debhelper-compat (= 13),
               docbook-xml,
               docbook-xsl,
               libkmod-dev,
               pkgconf,
               systemd-dev,
               xsltproc
Rules-Requires-Root: no
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/dracut
Vcs-Git: https://salsa.debian.org/debian/dracut.git
Homepage: https://github.com/dracut-ng/dracut-ng/wiki

Package: dracut-core
Architecture: any
Multi-Arch: foreign
Depends: cpio,
         dracut-install,
         e2fsprogs,
         gawk,
         kmod,
         udev,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: binutils,
            console-setup,
            cryptsetup,
            dmraid,
            dmsetup,
            kpartx,
            lvm2,
            mdadm,
            systemd,
            systemd-cryptsetup,
            systemd-sysv,
            zstd
Breaks: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
Replaces: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
Description: dracut is an event driven initramfs infrastructure (core tools)
 Unlike existing initramfs's, this is an attempt at having as little as
 possible hard-coded into the initramfs as possible.  The initramfs has
 (basically) one purpose in life -- getting the rootfs mounted so that
 it can transition to the real rootfs.  This is all driven off of
 device availability.  Therefore, instead of scripts hard-coded to do
 various things, it depends on udev to create device nodes and
 to detect the rootfs.
 Having the root on MD, LVM2, LUKS is supported as well as NFS, iSCSI,
 NBD and FCOE with dracut-network.

Package: dracut
Architecture: all
Multi-Arch: foreign
Depends: dracut-core (<< ${binary:Version}+b+~),
         dracut-core (>= ${binary:Version}),
         linux-base,
         ${misc:Depends}
Suggests: dracut-network
Provides: linux-initramfs-tool
Conflicts: initramfs-tools, live-tools
Description: Initramfs generator using udev
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: dracut-install
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: dracut-core (<< 060+5-7~)
Replaces: dracut-core (<< 060+5-7~)
Description: dracut is an event driven initramfs infrastructure (dracut-install)
 This package just contains the dracut-install command to be used by
 initramfs generating tools.

Package: dracut-network
Architecture: all
Depends: dracut-core,
         iputils-arping,
         isc-dhcp-client | systemd | connman | network-manager,
         ${misc:Depends}
Recommends: curl, iscsiuio, nbd-client, nfs-common, open-iscsi
Breaks: dracut-core (<< 105)
Replaces: dracut-core (<< 105)
Description: dracut is an event driven initramfs infrastructure (network modules)
 Package to build a dracut initramfs with network support. This
 includes dracut modules for NFS, CIFS, iSCSI, HTTP, NBD, FCP and FCOE.

Package: dracut-squash
Architecture: all
Depends: dracut-core, squashfs-tools, ${misc:Depends}
Breaks: dracut-core (<< 050-1)
Replaces: dracut-core (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (squashfs modules)
 Package to build an initramfs with most files in a squashfs image.
 .
 This package provides a dracut module to build an initramfs, but
 store most files in a squashfs image, result in a smaller initramfs
 size and reduce runtime memory usage.

Package: dracut-live
Architecture: all
Depends: dmsetup, dracut-core, ${misc:Depends}
Recommends: dracut-network
Breaks: dracut-core (<< 050-1), dracut-network (<< 050-1)
Replaces: dracut-core (<< 050-1), dracut-network (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (live image modules)
 Package to build a dracut initramfs with live image capabilities.
 .
 This package requires everything which is needed to build an
 initramfs with dracut, with live image capabilities, like Live CDs.

Package: dracut-config-generic
Architecture: all
Depends: dracut-core, ${misc:Depends}
Multi-Arch: foreign
Description: dracut is an event driven initramfs infrastructure
 This is the dracut configuration to turn off hostonly image generation

Package: dracut-config-rescue
Architecture: all
Depends: dracut-core, ${misc:Depends}
Multi-Arch: foreign
Description: dracut is an event driven initramfs infrastructure
 This is the dracut configuration to turn on rescue image generation

Package: dracut-test
Architecture: all
Depends: dracut-core, ${misc:Depends}
Breaks: dracut-core (<< 105)
Replaces: dracut-core (<< 105)
Description: dracut is an event driven initramfs infrastructure (test modules)
 This package provides the Dracut modules and configuration files for the
 Dracut test suite. This package is intended for testing Dracut itself
 and is of no use for ordinary users. If you're not sure about this package,
 you don't need it.

=== debian/rules ===
--- 
+++ 
@@ -5,14 +5,17 @@
 -include /usr/share/dpkg/buildtools.mk
 include /usr/share/dpkg/pkg-info.mk
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 export DRACUT_MAIN_VERSION=$(DEB_VERSION_UPSTREAM_REVISION)
 export DRACUT_FULL_VERSION=$(DEB_VERSION)
+# For "make install" to not install files needed for tests
+export enable_test=no
 
 deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)
 
 %:
-	dh $@ --with apport
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- --systemdsystemunitdir=/$(deb_systemdsystemunitdir) --libdir=/usr/lib
@@ -28,7 +31,7 @@
 override_dh_fixperms-indep:
 	dh_fixperms
 	find debian/ -name "*.sh" | grep modules.d | xargs chmod 755
-	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.asc
+	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.adoc
 	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.8
 ifneq ($(DEB_HOST_ARCH), s390x)
 	for m in 80cms 81cio_ignore 91zipl 95dasd 95dasd_mod \
@@ -51,4 +54,7 @@
 	   mv -f dracut-version.sh.orig dracut-version.sh ;\
 	fi
 	dh_clean dracut.pc Makefile.inc src/skipcpio/skipcpio src/util/util
-	git status|grep modified: | awk '/.asc/ {print $$2}' | xargs -r git checkout
+	if test -d .git; then \
+		git status|grep modified: | awk '/.adoc/ {print $$2}' | xargs -r git checkout;\
+		git checkout dracut.html ;\
+    fi

=== debian/tests/control ===
# Skip following test cases:
# * TEST-14-IMSM: dmraid was removed from Debian
# * TEST-30-ISCSI: iscsiuio.socket missing, see https://bugs.debian.org/1056733
# * TEST-35-ISCSI-MULTI: iscsiuio.socket missing, see https://bugs.debian.org/1056733
# * TEST-50-MULTINIC: disabled in upstream CI since 2023-01-02
# * TEST-60-BONDBRIDGEVLAN: https://github.com/dracutdevs/dracut/issues/2328
# arm64, armhf, ppc64el, and s390x need upstream support: https://github.com/dracutdevs/dracut/issues/2493
Architecture: amd64
Test-Command: debian/tests/run-upstream-tests SKIP="14 16 20 30 35 40 50 60"
Depends: btrfs-progs,
         busybox,
         cryptsetup,
         dracut-core,
         dracut-test,
         fdisk,
         kbd,
         linux-image-generic,
         lvm2,
         make,
         mdadm,
         mount,
         ovmf,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         squashfs-tools,
         systemd-boot-efi [amd64 arm64 armhf riscv64],
         systemd-coredump,
         systemd-cryptsetup,
         systemd-repart,
         systemd-sysv,
         systemd-ukify,
         util-linux,
         zstd
Restrictions: allow-stderr
Features: test-name=upstream-dracut-core

Architecture: amd64
Test-Command: debian/tests/run-upstream-tests TESTS="16"
Depends: btrfs-progs,
         busybox,
         dracut-live,
         dracut-test,
         fdisk,
         kbd,
         linux-image-generic,
         make,
         mount,
         parted,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         squashfs-tools,
         systemd-sysv,
         util-linux,
         zstd
Restrictions: allow-stderr
Features: test-name=upstream-dracut-live

Architecture: amd64
Test-Command: debian/tests/run-upstream-tests TESTS="20"
Depends: dracut-live,
         dracut-network,
         dracut-test,
         iproute2,
         isc-dhcp-client,
         isc-dhcp-server,
         linux-image-generic,
         make,
         mount,
         nfs-kernel-server,
         procps,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         systemd,
         systemd-sysv,
         sysvinit-utils,
         util-linux,
         zstd
Restrictions: allow-stderr
Features: test-name=upstream-dracut-network-nfs

Architecture: amd64
Test-Command: debian/tests/run-upstream-tests TESTS="40"
Depends: cryptsetup,
         dracut-network,
         dracut-test,
         iproute2,
         isc-dhcp-client,
         isc-dhcp-server,
         linux-image-generic,
         lvm2,
         make,
         mdadm,
         mount,
         nbd-client,
         nbd-server,
         procps,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         systemd,
         systemd-cryptsetup,
         systemd-sysv,
         util-linux,
         zstd
